//
// Copyright (c) 2006 Regents of the SIGNET lab, University of Padova.
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 3. Neither the name of the University of Padova (SIGNET lab) nor the 
//    names of its contributors may be used to endorse or promote products 
//    derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED 
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//


#include "modsend-clmsg.h"
#include "clsap.h"


extern ClMessage_t SANDBOXMSG;

/*-------------------------------------------------------------------------------------------------------
	methods for ClMsgModuleSend class
---------------------------------------------------------------------------------------------------------*/ 

ClMsgModuleSend::ClMsgModuleSend(int iface) : ClMessage(SANDBOXMSGVERB, SANDBOXMSG), iface_(iface) {}

ClMsgModuleSend::ClMsgModuleSend(ClMsgModuleSend *m) : ClMessage(m)
{
	iface_ = m->iface_;
}

ClMsgModuleSend::ClMsgModuleSend(int verbosity, DestinationType dtype, int source, int value, int iface): ClMessage(verbosity, SANDBOXMSG, dtype, source, value), iface_(iface) 
{
}

int ClMsgModuleSend::getIface()
{
	return(iface_);
}


// retrun a copy of the message
ClMessage *ClMsgModuleSend::copy()
{
	ClMessage *temp = new ClMsgModuleSend(this);
	return (temp);
}

/*-------------------------------------------------------------------------------------------------------
	methods for ClSandboxTracer class
---------------------------------------------------------------------------------------------------------*/ 

ClSandboxTracer::ClSandboxTracer() : ClMessageTracer(0)
{
}

void ClSandboxTracer::format(ClMessage *m, ConnectorTrace *sap)
{
	// ad hoc format to trace this cross layer message, it is indicated the iface that has to be used
	writeTrace(sap, " [SNBX: -iface %d ]",((ClMsgModuleSend*)m)->getIface());
}


