//
// Copyright (c) 2006 Regents of the SIGNET lab, University of Padova.
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 3. Neither the name of the University of Padova (SIGNET lab) nor the 
//    names of its contributors may be used to endorse or promote products 
//    derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED 
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//


#ifndef _CLMSGSANDBOXPLG1_
#define _CLMSGSANDBOXPLG1_

#include "clmessage.h"
#include "cltracer.h"

#define SANDBOXPLG1MSGVERB 1

class ClSAP;

/*
	define a cross-layer message that allows to discover the id of the send-module
*/

class ClMsgSandboxPlg1Disc : public ClMessage
{
	public:
		ClMsgSandboxPlg1Disc();
		ClMsgSandboxPlg1Disc(ClMsgSandboxPlg1Disc *m);
		ClMsgSandboxPlg1Disc(int verbosity, DestinationType dtype, int source, int value);
		
		ClMessage* copy();	// copy the message
		
	private:
	
};


class ClMsgSandboxPlg1DiscTracer : public ClMessageTracer
{
	public:
		ClMsgSandboxPlg1DiscTracer();
		void format(ClMessage *m, ConnectorTrace *sap);
};


class ClMsgSandboxPlg1Set : public ClMessage
{
	public:
		ClMsgSandboxPlg1Set();
		ClMsgSandboxPlg1Set(ClMsgSandboxPlg1Set *m);
		ClMsgSandboxPlg1Set(int verbosity, DestinationType dtype, int source, int value, int newSize);
		
		ClMessage* copy();	// copy the message
		
		int getSize();		// get the size
		
	private:
	
		int newSize_;
};


class ClMsgSandboxPlg1SetTracer : public ClMessageTracer
{
	public:
		ClMsgSandboxPlg1SetTracer();
		void format(ClMessage *m, ConnectorTrace *sap);
};

#endif
